The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Delay Class Reference

STK non-interpolating delay line class. More...

`#include <Delay.h>`

Inheritance diagram for stk::Delay:

## Public Member Functions
| Delay (unsigned long delay=0, unsigned long maxDelay=4095)
| The default constructor creates a delay-line with maximum length of 4095 samples and zero delay.
| ~Delay ()
| Class destructor.
unsigned long | getMaximumDelay (void)
| Get the maximum delay-line length.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay-line length.
void | setDelay (unsigned long delay)
| Set the delay-line length.
unsigned long | getDelay (void) const
| Return the current delay-line length.
StkFloat | tapOut (unsigned long tapDelay)
| Return the value at tapDelay samples from the delay-line input.
void | tapIn (StkFloat value, unsigned long tapDelay)
| Set the value at tapDelay samples from the delay-line input.
StkFloat | addTo (StkFloat value, unsigned long tapDelay)
| Sum the provided value into the delay line at tapDelay samples from the input.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | nextOut (void)
| Return the value that will be output by the next call to tick().
StkFloat | energy (void) const
| Calculate and return the signal energy in the delay-line.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK non-interpolating delay line class.

This class implements a non-interpolating digital delay-line. If the delay and maximum length are not specified during instantiation, a fixed maximum length of 4095 and a delay of zero is set.

A non-interpolating delay line is typically used in fixed delay-length applications, such as for reverberation.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ Delay()

stk::Delay::Delay | ( | unsigned long | delay = `0`,
|  | unsigned long | maxDelay = `4095`
| ) |  |

The default constructor creates a delay-line with maximum length of 4095 samples and zero delay.

An StkError will be thrown if the delay parameter is less than zero, the maximum delay parameter is less than one, or the delay parameter is greater than the maxDelay value.

## Member Function Documentation

## ◆ setMaximumDelay()

void stk::Delay::setMaximumDelay | ( | unsigned long | delay | ) |

Set the maximum delay-line length.

This method should generally only be used during initial setup of the delay line. If it is used between calls to the tick() function, without a call to clear(), a signal discontinuity will likely occur. If the current maximum length is greater than the new length, no memory allocation change is made.

## ◆ setDelay()

void stk::Delay::setDelay | ( | unsigned long | delay | ) |

Set the delay-line length.

The valid range for delay is from 0 to the maximum delay-line length.

## ◆ tapOut()

StkFloat stk::Delay::tapOut | ( | unsigned long | tapDelay | ) |

Return the value at tapDelay samples from the delay-line input.

The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero returns the last input value).

## ◆ addTo()

StkFloat stk::Delay::addTo | ( | StkFloat | value,
|  | unsigned long | tapDelay
| ) |  |

Sum the provided value into the delay line at tapDelay samples from the input.

The new value is returned. The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero sums into the last input value).

## ◆ nextOut()

StkFloat stk::Delay::nextOut | ( | void |  | ) |
| inline

Return the value that will be output by the next call to tick().

This method is valid only for delay settings greater than zero!

87{ return inputs_[outPoint_]; };

## ◆ tick() [1/2]

StkFrames & stk::Delay::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

142{
143#if defined(_STK_DEBUG_)
144 if ( channel >= frames.channels() ) {
145 oStream_ << "Delay::tick(): channel and StkFrames arguments are incompatible!";
146 handleError( StkError::FUNCTION_ARGUMENT );
147 }
148#endif
149
150 StkFloat *samples = &frames[channel];
151 unsigned int hop = frames.channels();
152 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
153 inputs_[inPoint_++] = *samples * gain_;
154 if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
155 *samples = inputs_[outPoint_++];
156 if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
157 }
158
159 lastFrame_[0] = *(samples-hop);
160 return frames;
161}
stk::StkFrames::size
size_t size() const
Returns the total number of audio samples represented by the object.
Definition Stk.h:374
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::Delay::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

164{
165#if defined(_STK_DEBUG_)
166 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
167 oStream_ << "Delay::tick(): channel and StkFrames arguments are incompatible!";
168 handleError( StkError::FUNCTION_ARGUMENT );
169 }
170#endif
171
172 StkFloat *iSamples = &iFrames[iChannel];
173 StkFloat *oSamples = &oFrames[oChannel];
174 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
175 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
176 inputs_[inPoint_++] = *iSamples * gain_;
177 if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
178 *oSamples = inputs_[outPoint_++];
179 if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
180 }
181
182 lastFrame_[0] = *(oSamples-oHop);
183 return iFrames;
184}

The documentation for this class was generated from the following file:

- Delay.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.